import { Tensor, Tensor2D } from '@tensorflow/tfjs';
export declare class KNNClassifier {
    private trainDatasetMatrix;
    private classDatasetMatrices;
    private classExampleCount;
    private exampleShape;
    addExample(example: Tensor, classIndex: number): void;
    private similarities;
    predictClass(input: Tensor, k?: number): Promise<{
        classIndex: number;
        confidences: {
            [classId: number]: number;
        };
    }>;
    clearClass(classIndex: number): void;
    clearAllClasses(): void;
    getClassExampleCount(): {
        [classId: number]: number;
    };
    getClassifierDataset(): {
        [classId: number]: Tensor2D;
    };
    getNumClasses(): number;
    setClassifierDataset(classDatasetMatrices: {
        [classId: number]: Tensor2D;
    }): void;
    private calculateTopClass;
    private clearTrainDatasetMatrix;
    private normalizeVectorToUnitLength;
    private getNumExamples;
    dispose(): void;
}
export declare function create(): KNNClassifier;
